import java.util.*;

public class StringPadding extends Object
{
	private static final int LOOPS = 100000;
	private static final String CHARS = new  String("abcdefghijklmnopqrstuvwxyz");
	private static final int STRINGLENGTH = 40;
	
	private static HashMap paddingCache;
	
	private static String generateString()
	{
 		StringBuffer toReturn =new StringBuffer();
 		Random r = new Random();
 		int index = 0;
		int length = r.nextInt(STRINGLENGTH)+1; // Prevents it being zero and allows it to be 10..
 		for(int i=1;i<=length;i++){
 			index = r.nextInt(26);
 			toReturn.append(CHARS.charAt(index));
 		}
 		return toReturn.toString();
	}

	public static String padCache(String inputString, char padding, int length)
	{
		String[] cachedPadding = (String[]) paddingCache.get(new Character(padding));
		if (cachedPadding == null)
		{
			System.out.println("Here");
			cachedPadding = new String[length];
			StringBuffer pad = new StringBuffer(0);
			for (int i=0;i<length;i++)
			{
				pad.append(padding);
				cachedPadding[i] = pad.toString();
			}
			paddingCache.put(new Character(padding),cachedPadding);
		}
		StringBuffer temp =  new StringBuffer(inputString);
		temp.append(cachedPadding[length - inputString.length()]);
		return temp.toString();
	}

	public static String padLoop(String inputString, char padding, int length)
	{
		StringBuffer toReturn = new StringBuffer(inputString);
		while(toReturn.length()<length)
		{
			toReturn.append(padding);
		}
		return toReturn.toString();
	}

	public static void main(String args[])
	{
		paddingCache = new HashMap();
		System.out.println("About to generate test data");
		String[] inputs = new String[LOOPS];
		int i;
		for (i=0;i<LOOPS;i++)
		{
			inputs[i] = generateString();
		}
		System.out.println("Generated test data");
		
		System.out.println("Testing padLoop");
		long start = System.currentTimeMillis();
		for (i=0;i<LOOPS;i++)
		{
			padLoop(inputs[i],'x',STRINGLENGTH);
		}
		long stop = System.currentTimeMillis();
		long loopTime = stop - start;
		System.out.println("padLoop done");
		
		System.out.println("Testing padCache");
		start = System.currentTimeMillis();
		for (i=0;i<LOOPS;i++)
		{
			padCache(inputs[i],'x',STRINGLENGTH);
		}
		stop = System.currentTimeMillis();
		long cacheTime = stop - start;
		System.out.println("padCache done");
		
		System.out.println("padLoop time was "+loopTime);
		System.out.println("padCache time was "+cacheTime);
	}
}